package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10064ZhengShuResult;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10064SeedsGetZhengShu extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10064 = 10064;
	private Gson gson;
	private Prot10064ZhengShuResult res;

	public Prot10064SeedsGetZhengShu() {

		gson = new Gson();
	}
	

	public Prot10064ZhengShuResult getRes() {
		return res;
	}


	public void setRes(Prot10064ZhengShuResult res) {
		this.res = res;
	}


	public void dealGetDealer(SocketCreate create) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis());
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis) throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10064, "开始请求产品列表");
				sendProt(dos);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recZhengShu(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos) throws IOException {
		String bodyContent = "{}";
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10064, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recZhengShu(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10064, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10064, jsonData);

		if (!StrUtils.isEmpty(jsonData)) {
			
			res = gson.fromJson(jsonData, Prot10064ZhengShuResult.class);
		}
		recCheckCode(dis);
	}

}
